#include<iostream>
#include<cstring>
using namespace std;
bool glavnoLiE(char bukva){
    if(bukva > 'Z'){
        return false;
    }else{
        return true;
    }
}
bool bukvaLiE(char znac){
    if((znac >= 'A' && znac <= 'Z') || (znac >= 'a' && znac <= 'z')){
        return true;
    }else{
        return false;
    }
}
int main(){
    char vhod[1005], buff[1000];
    for(int i = 0; i < 1005; i++){
        vhod[i] = 32;
    }
    int addingTo = 0, vhodLenght, n;
    bool done = false;
    for(int i = 0; buff[strlen(buff)] != '.'; i++){
        cin >> buff;
        for(int j = 0; j < strlen(buff); j++){
            vhod[addingTo] = buff[j];
            addingTo++;
        }
        addingTo++;
        for(int i = 0; i < 105; i++){
            if(vhod[i] == '.' || vhod[i] == '?' || vhod[i] == '!'){
                done = true;
                vhodLenght = i + 1;
            }
        }
        if(done){
            break;
        }
    }
    cin >> n;
    n = n % 26;
    for(int i = 0; i < vhodLenght; i++){
        if(bukvaLiE(vhod[i])){
            char izhod;
            if(glavnoLiE(vhod[i])){
                if(vhod[i] - n < 'A'){
                    izhod = 'Z' - ('A' - vhod[i] - n);
                }else{
                    izhod = vhod[i] - n;
                }
            }else{
                if(vhod[i] - n < 'a'){
                    izhod = 'z' - ('a' - vhod[i] - n);
                }else{
                    izhod = vhod[i] - n;
                }
            }
            cout << izhod;
        }else{
            cout << vhod[i];
        }
    }
    return 0;
}
